<?PHP
    // Version 5 14:59

    Header ("Expires: -1");
    Header ("Cache-Control: post-check=0, pre-check=0");
    Header ("Pragma: no-cache");
    Header ("Last-Modified: ".gmdate("D, d M Y H:i:s"). " GMT");
    include ("../system/header.php");
    include ("../system/mysql_connect.php");



// Die Funktion ueberprueft, ob es einen freien Platz in dem Projekt der
// vorgegebenen Wahlstufe gibt, und liefert als Ergebnis die Projektnummer.

function Platzfrei ($Schueler, $Wahlprioritaet, &$PNr){
  $SQL_Befehl = "Select projekt.PNr
                   From projekt, wahl
                   Where SLogin = '$Schueler'
                   and Prioritaet =  $Wahlprioritaet
                   and projekt.PNr = wahl.PNr
                   and BelegtePlaetze < TeilnehmerMax";
  $result = mysql_query($SQL_Befehl);
  $menge = mysql_num_rows($result);
  if ($menge > 0) {
     $row = mysql_fetch_row($result);
     $PNr = $row[0];      // 0 ist PNr
     $Ergebnis = true;
  }
  else $Ergebnis = false;
  mysql_free_result($result);
  return  $Ergebnis;
}


// Der Schueler wird in dem Projekt aufgenommen und die Anzahl der belegten
// Plaetze wird um 1 erhoeht.

function Zuweisung ($SLogin, $PNr, $Prioritaet) {
  $SQL_Befehl = "update sus set PNr = $PNr, ZugetPrior = $Prioritaet
                 where SLogin = '$SLogin'";
  $result = mysql_query($SQL_Befehl);
  if ($result){
  $SQL_Befehl = "update projekt set BelegtePlaetze = BelegtePlaetze + 1
                 where PNr = $PNr";
   $result = mysql_query($SQL_Befehl);
  }
  else
   echo "Fehler in Zuweisung";
  mysql_free_result($result);
}


// Ein Schueler wird in ein anderes Projekt gesetzt. Dabei aendert sich die
// Anzahl der belegten Plaetze nicht.

function Ersetzen ($SLogin, $PNr, $Prioritaet) {
  $SQL_Befehl = "update sus set PNr = $PNr, ZugetPrior = $Prioritaet
                 where SLogin = '$SLogin'";
  $result = mysql_query($SQL_Befehl);
  mysql_free_result($result);
}


// Ein schon zugewiesener Schueler rutscht in ein anderes Projekt und auf den
// frei gewordenen Platz rutscht ein neuer Schueler.

function Umsetzen($neuerSchueler, $umzusetzenderSchueler, $vonPNr, $nachPNr, $PrioritaetNeuerSchueler, $PrioritaetUmzusetzenderSchueler){
    Zuweisung ($umzusetzenderSchueler, $nachPNr, $PrioritaetUmzusetzenderSchueler);
    Ersetzen ($neuerSchueler, $vonPNr, $PrioritaetNeuerSchueler);
}


//  Es wird in einem vollem Projekt mit vorgegebener Wahlprioritaet
//  ein noch offenes Projekt und ein umzusetzender Schueler mit vorgegebener
// Wahlstufe gesucht und zur&uuml;ck geliefert.

function WechselPlatzFrei ( $vollePNr, $Wahlprioritaet, $Wahlstufe, &$umzusetzenderSchueler, &$offenePNr) {
 $SQL_Befehl = "Select sus.SLogin, projekt.PNr
                From sus, wahl, projekt
                where sus.PNr = $vollePNr and sus.ZugetPrior = $Wahlprioritaet
                and sus.SLogin = wahl.SLogin and wahl.Prioritaet = $Wahlstufe
                and wahl.PNr = projekt.PNr and BelegtePlaetze < TeilnehmerMax";
 $result = mysql_query ($SQL_Befehl);
 $menge = mysql_num_rows($result);
 if ($menge > 0) {
     $row = mysql_fetch_row($result);
     $umzusetzenderSchueler = $row[0];      // 0 ist SLogin
     $offenePNr = $row[1];         // 1 ist PNr
     $Ergebnis = true;
 }
 else
     $Ergebnis = false;
 mysql_free_result($result);
 return $Ergebnis;
}


// Bei vorgegebener Wahlprioritaet wird f&uuml;r einen Schueler die dazugeh&ouml;rige
// Projektnummer bestimmt.

function gewaehltesProjekt($SLogin, $Wahlprioritaet){
 $SQL_Befehl = "Select wahl.PNr
                From sus, wahl
                where sus.SLogin = '$SLogin' and sus.SLogin = wahl.SLogin
                and wahl.Prioritaet = $Wahlprioritaet";
 $result = mysql_query ($SQL_Befehl);
 $menge = mysql_num_rows($result);
 if ($menge > 0) {
     $row = mysql_fetch_row($result);
     $Ergebnis = $row[0];            // 0 ist PNr
 }
 else $Ergebnis = -1;
 mysql_free_result($result);
 return $Ergebnis;
}


// Im Erstwahl-Projekt des aktSchuelers ist noch ein Platz frei.

function Fall1($aktSchueler){
 global $zugeteilt;
 if (Platzfrei($aktSchueler, 1, $PNr)) {
     Zuweisung($aktSchueler, $PNr, 1);
     $zugeteilt = true;
     echo "Fall 1: $PNr";
 }
}


// Im Zweitwahl-Projekt des aktSchuelers ist noch ein Platz frei.

function Fall2($aktSchueler) {
 global $zugeteilt;
 if (Platzfrei($aktSchueler, 2, $PNr)){
     Zuweisung($aktSchueler,$PNr, 2);
     $zugeteilt = true;
     echo "Fall 2: $PNr";
 }
}


// Das Erstwahl- und Zweitwahl-Projekt des aktSchuelers ist voll.
// Es gibt im Erstwahl-Projekt einen anderen Schueler, dessen Erstwahl
// dies ist und in dessen Zweitwahl-Projekt noch ein Platz frei ist.

function Fall3($aktSchueler) {
  global $zugeteilt;
  $vollePNr =  gewaehltesProjekt($aktSchueler, 1);
  if (WechselPlatzFrei($vollePNr, 1, 2, $umzusetzenderSchueler, $offenePNr)){
      Umsetzen($aktSchueler, $umzusetzenderSchueler, $vollePNr, $offenePNr,1, 2);
      $zugeteilt = true;
      echo "Fall 3: $vollePNr nach $offenePNr";
  }
}


// Das Erstwahl- und Zweitwahl-Projekt des aktSchuelers ist voll.
// Es gibt im Zweitwahl-Projekt einen anderen Schueler, dessen Erstwahl
// dies ist und in dessen Zweitwah-Projekt noch ein Platz frei ist.

function Fall4($aktSchueler) {
 global $zugeteilt;
 $vollePNr = gewaehltesProjekt($aktSchueler, 2);
 if (WechselPlatzFrei($vollePNr, 1, 2, $umzusetzenderSchueler, $offenePNr)) {
    Umsetzen($aktSchueler, $umzusetzenderSchueler, $vollePNr, $offenePNr, 2, 2);
    $zugeteilt = true;
    echo "Fall 4: $vollePNr nach $offenePNr";
 }
}


// Das Erstwahl- und Zweitwahl-Projekt des aktSchuelers ist voll.
// Im Erstwahl-Projekt gibt es einen Hilfsschueler, dessen Erstwahl dies ist und
// der in seine Zweitwahl rutscht, da es dort einen umzusetzenden Schueler gibt,
// dessen Erstwahl dies ist und der in seine Zweitwahl rutscht.

function Fall5($aktSchueler) {
 global $zugeteilt;
 $aktvollePNr =  gewaehltesProjekt($aktSchueler, 1);
 $SQL_Befehl = "Select SLogin
                From sus
                where PNr = $aktvollePNr and ZugetPrior = 1";
 $result = mysql_query ($SQL_Befehl);
 while($row = mysql_fetch_row($result) and  (! $zugeteilt)) {
       $HilfsSchueler = $row[0];                // 0 ist SLogin
       $hilfsvollePNr = gewaehltesProjekt($HilfsSchueler, 2);
       if (WechselPlatzFrei($hilfsvollePNr, 1, 2, $umzusetzenderSchueler, $offenePNr)) {
           Umsetzen($HilfsSchueler, $umzusetzenderSchueler, $hilfsvollePNr, $offenePNr,2, 2);
           Ersetzen ($aktSchueler, $aktvollePNr, 1);
           $zugeteilt = true;
           echo "Fall 5: $hilfsvollePNr nach $offenePNr";
       }
 }
 mysql_free_result($result);
}


// Das Erstwahl- und Zweitwahl-Projekt des aktSchuelers ist voll.
// Im Zweitwahl-Projekt gibt es einen Hilfsschueler, dessen Erstwahl dies ist und
// der in seine Zweitwahl rutscht, da es dort einen umzusetzenden Schueler gibt,
// dessen Erstwahl dies ist und der in seine Zweitwahl rutscht.

function Fall6($aktSchueler) {
 global $zugeteilt;
 $aktvollePNr =  gewaehltesProjekt($aktSchueler, 2);
 $SQL_Befehl = "Select SLogin
                From sus
                where PNr = $aktvollePNr and ZugetPrior = 1";
 $result = mysql_query ($SQL_Befehl);
 while($row = mysql_fetch_row($result) and  (! $zugeteilt)) {
       $HilfsSchueler = $row[0];          // 0 ist SLogin
       $hilfsvollePNr = gewaehltesProjekt($HilfsSchueler, 2);
       if (WechselPlatzFrei($hilfsvollePNr, 1, 2, $umzusetzenderSchueler, $offenePNr)) {
           Umsetzen($HilfsSchueler, $umzusetzenderSchueler, $hilfsvollePNr, $offenePNr,2, 2);
           Ersetzen ($aktSchueler, $aktvollePNr, 2);
           $zugeteilt = true;
           echo "Fall 6: $hilfsvollePNr nach $offenePNr";
       }
 }
 mysql_free_result($result);
}


// Im Drittwahl-Projekt des aktSchuelers ist noch ein Platz frei.

function Fall7($aktSchueler) {
 global $zugeteilt;
 if (Platzfrei($aktSchueler, 3, $PNr)){
     Zuweisung($aktSchueler, $PNr,3);
     $zugeteilt = true;
     echo "Fall 7: $PNr";
 }
}


// Das Erstwahl-, Zweit- und Drittwahl-Projekt des aktSchuelers ist voll.
// Es gibt im Erstwahl-Projekt einen anderen Schueler, dessen Zweitwahl
// dies ist und in dessen Drittwahl-Projekt noch ein Platz frei ist.

function Fall8($aktSchueler) {
 global $zugeteilt;
 $vollePNr =  gewaehltesProjekt($aktSchueler, 1);
  if (WechselPlatzFrei($vollePNr, 2, 3, $umzusetzenderSchueler, $offenePNr)){
      Umsetzen($aktSchueler, $umzusetzenderSchueler, $vollePNr, $offenePNr, 1,3);
      $zugeteilt = true;
      echo "Fall 8: $hilfsvollePNr nach $offenePNr";
  }
}


// Das Erstwahl-, Zweit- und Drittwahl-Projekt des aktSchuelers ist voll.
// Im Erstwahl-Projekt gibt es einen Hilfsschueler, dessen Erstwahl dies ist und
// der in seine Zweitwahl rutscht, da es dort einen umzusetzenden Schueler gibt,
// dessen Zweitwahl dies ist und der in seine Drittwahl rutscht.

function Fall9($aktSchueler) {
 global $zugeteilt;
 $aktvollePNr =  gewaehltesProjekt($aktSchueler, 1);
 $SQL_Befehl = "Select SLogin
                From sus
                where PNr = $aktvollePNr and ZugetPrior = 1";
 $result = mysql_query ($SQL_Befehl);
 while($row = mysql_fetch_row($result) and  (! $zugeteilt)) {
       $HilfsSchueler = $row[0];          // 0 ist SLogin
       $hilfsvollePNr = gewaehltesProjekt($HilfsSchueler, 2);
       if (WechselPlatzFrei($hilfsvollePNr, 2, 3, $umzusetzenderSchueler, $offenePNr)) {
           Umsetzen($HilfsSchueler, $umzusetzenderSchueler, $hilfsvollePNr, $offenePNr,2, 3);
           Ersetzen ($aktSchueler, $aktvollePNr, 1);
           $zugeteilt = true;
           echo "Fall 9: $hilfsvollePNr nach $offenePNr";
       }
 }
 mysql_free_result($result);
}


// Das Erstwahl-, Zweit- und Drittwahl-Projekt des aktSchuelers ist voll.
// Es gibt im Drittwahl-Projekt einen anderen Schueler, dessen Erstwahl
// dies ist und in dessen Zweitwahl-Projekt noch ein Platz frei ist.

function Fall10($aktSchueler) {
 global $zugeteilt;
 $vollePNr =  gewaehltesProjekt($aktSchueler, 3);
  if (WechselPlatzFrei($vollePNr, 1, 2, $umzusetzenderSchueler, $offenePNr)){
      Umsetzen($aktSchueler, $umzusetzenderSchueler, $vollePNr, $offenePNr, 3, 2);
      $zugeteilt = true;
      echo "Fall 10: $vollePNr nach $offenePNr";
  }
}


// Das Erstwahl-, Zweit- und Drittwahl-Projekt des aktSchuelers ist voll.
// Es gibt im Zweitwahl-Projekt einen anderen Schueler, dessen Zweitwahl
// dies ist und in dessen Drittwahl-Projekt noch ein Platz frei ist.

function Fall11($aktSchueler) {
 global $zugeteilt;
 $vollePNr =  gewaehltesProjekt($aktSchueler, 2);
  if (WechselPlatzFrei($vollePNr, 2, 3, $umzusetzenderSchueler, $offenePNr)){
      Umsetzen($aktSchueler, $umzusetzenderSchueler, $vollePNr, $offenePNr, 2, 3);
      $zugeteilt = true;
      echo "Fall 11: $vollePNr nach $offenePNr";
  }
}


// Das Erstwahl- und Zweitwahl-Projekt des aktSchuelers ist voll.
// Im Zweitwahl-Projekt gibt es einen Hilfsschueler, dessen Erstwahl dies ist und
// der in seine Zweitwahl rutscht, da es dort einen umzusetzenden Schueler gibt,
// dessen Zweitwahl dies ist und der in seine Drittwahl rutscht.

function Fall12($aktSchueler) {
 global $zugeteilt;
 $aktvollePNr =  gewaehltesProjekt($aktSchueler, 2);
 $SQL_Befehl = "Select SLogin
                From sus
                where PNr = $aktvollePNr and ZugetPrior = 1";
 $result = mysql_query ($SQL_Befehl);
 while($row = mysql_fetch_row($result) and  (! $zugeteilt)) {
       $HilfsSchueler = $row[0];             // 0 ist SLogin
       $hilfsvollePNr = gewaehltesProjekt($HilfsSchueler, 2);
       if (WechselPlatzFrei($hilfsvollePNr, 2, 3, $umzusetzenderSchueler, $offenePNr)) {
           Umsetzen($HilfsSchueler, $umzusetzenderSchueler, $hilfsvollePNr, $offenePNr,2, 3);
           Ersetzen ($aktSchueler, $aktvollePNr, 2);
           $zugeteilt = true;
           echo "Fall 12: $hilfsvollePNr nach $offenePNr";
       }
 }
 mysql_free_result($result);
}




// Hauptprogramm

// Zuteilung der Schueler

$zugeteilt = false;

$SQL_Befehl ="Select SLogin
                From sus
                Where PNr = -1
                order by rand()";

$result = mysql_query($SQL_Befehl);

while($row = mysql_fetch_array($result)) {
 $aktSchueler = $row["SLogin"];
 set_time_limit(30);
 echo "<br> Schueler: '$aktSchueler'";
 $zugeteilt = false;
 if (! $zugeteilt) Fall1($aktSchueler);
 if (! $zugeteilt) Fall2($aktSchueler);
 if (! $zugeteilt) Fall3($aktSchueler);
 if (! $zugeteilt) Fall4($aktSchueler);
 if (! $zugeteilt) Fall5($aktSchueler);
 if (! $zugeteilt) Fall6($aktSchueler);
 if (! $zugeteilt) Fall7($aktSchueler);
 if (! $zugeteilt) Fall8($aktSchueler);
 if (! $zugeteilt) Fall9($aktSchueler);
 if (! $zugeteilt) Fall10($aktSchueler);
 if (! $zugeteilt) Fall11($aktSchueler);
 if (! $zugeteilt) Fall12($aktSchueler);
}
mysql_free_result($result);

echo "Zuteilung fertig!";

include ("../system/footer.php");

?>